package com.joelhelkala.watcherServer.appuser;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping(path = "api/v1/appuser")
public class AppUserController {

    private final AppUserService userService;

    @Autowired
    public AppUserController(AppUserService userService) {
        this.userService = userService;
    }

    // Endpoint for person GET request which returns all the users
    @GetMapping
    public List<AppUser> getUsers() {
        return userService.getUsers();
    }

    // Endpoint for person POST request which creates a new user
    @PostMapping
    public void registerNewUser(@RequestBody AppUser user) {
        userService.addNewUser(user);
    }

    // Endpoint to delete a user with given id
    // TODO: perhaps change to email?
    @DeleteMapping(path = "{personId}")
    public void deletePerson(@PathVariable("personId") Long id) {
        userService.deleteUser(id);
    }

    // Endpoint to update a user with given id
    // TODO: perhaps change to email?
    @PutMapping(path = "{personId}")
    public void updateUser(@PathVariable("personId") Long id,
                             @RequestParam(required = false) String name,
                             @RequestParam(required = false) String email) {
        userService.updateUser(id, name, email);
    }
}
